menu channel,menubar {
  -
  S-Quiz $ver
  .Script ( $+ $group(#squiz) $+ )
  ..$iif($group(#squiz) == on,$style(3)) On:.enable #squiz
  ..$iif($group(#squiz) == off,$style(3)) Off:.disable #squiz
  .-
  .General:squiz general
  .Settings:squiz settings
  .Advanced Settings:squiz advanced settings
  .Edit Points:squiz points
  .-
  .Edit Congratulations:dialog $iif($dialog(squiz_congrats),-v,-m squiz_congrats) squiz_congrats
  .$iif($squiz(general).hints == default,$style(2)) Edit Hints:dialog $iif($dialog(squiz_hints),-v,-m squiz_hints) squiz_hints
  .-
  .Help:dialog $iif($dialog(squiz_help),-v,-m squiz_help) squiz_help
  .-
  .$iif(!$isfile($squiz.versions),$style(2)) Versions:run $squiz.versions
  .$iif(!$isfile($squiz.readme),$style(2)) Readme:run $squiz.readme
  .-
  .Unload: if ($input(Are you sure you want to unload S-Quiz $ver $+ ?,wy,Unload S-Quiz $ver)) .unload -rs $script
}

dialog s-quiz {
  title "S-Quiz"
  size -1 -1 161 138
  option dbu

  tab "General", 91, 2 0 154 122
  box "Quiz in these Channels:", 300, 5 16 69 70, tab 91
  edit "", 1, 8 24 50 10, tab 91
  list 2, 8 33 50 50, tab 91 size
  button "+", 3, 59 24 13 10, tab 91
  button "-", 4, 59 35 13 10, tab 91
  box "Hints", 350, 5 86 69 31, tab 91
  radio "Use Default", 96, 8 94 37 10, group tab 91
  radio "Custom Hints:", 98, 8 104 42 10, tab 91
  link "Default?", 97, 50 95 20 8, tab 91
  button "Edit", 99, 52 105 19 9, tab 91
  box "Q&&A File", 301, 76 16 77 29, tab 91
  text "Questions and Answers File:", 500, 79 23 68 8, tab 91
  edit "", 5, 79 31 59 10, tab 91 read autohs
  button "...", 6, 139 31 11 10, tab 91
  box "How To End Quiz", 302, 76 45 77 72, tab 91
  radio "Rounds:", 7, 79 53 30 11, group tab 91
  edit "", 555, 109 54 17 9, tab 91, limit 2 center
  radio "Points:", 12, 79 83 26 10, tab 91
  edit "", 13, 109 84 17 9, tab 91 autohs limit 3 center
  radio "Until Database is empty", 14, 79 93 66 10, tab 91
  radio "Continuous Play", 15, 79 104 50 10, tab 91
  ; intented
  radio "Points:", 8, 85 63 26 10, group tab 91
  edit "", 9, 121 64 17 9, tab 91 autohs limit 3 center
  radio "Questions:", 10, 85 73 35 10, tab 91
  edit "", 11, 121 74 17 9, tab 91 autohs limit 3 center
  link "Help", 16, 139 106 11 8, tab 91

  tab "Settings", 104
  box "Time Settings", 303, 5 18 43 54, tab 104
  text "Start:", 499, 8 27 14 8, tab 104
  edit "", 17, 29 28 16 9, tab 104 autohs limit 2 center
  text "Hints:", 501, 8 38 14 8, tab 104
  edit "", 18, 29 39 16 9, tab 104 autohs limit 2 center
  text "Answer:", 502, 8 49 20 8, tab 104
  edit "", 19, 29 50 16 9, tab 104 autohs limit 3 center
  text "Next Q:", 503, 8 60 19 8, tab 104
  edit "", 20, 29 61 16 9, tab 104 autohs limit 2 center
  box "Colors", 305, 5 72 42 45, tab 104
  combo 21, 8 80 36 34, tab 104 size drop
  text "Color 1:", 530, 8 93 19 8, tab 104
  edit "", 22, 28 92 16 9, tab 104 limit 2 center
  text "Color 2:", 531, 8 105 19 8, tab 104
  edit "", 23, 28 104 16 9, tab 104 limit 2 center
  ;combo 22, 8 92 36 34, tab 104 size drop
  ;combo 23, 8 104 36 34, tab 104 size drop
  box "Triggers available while Quiz is running", 304, 50 18 102 89, tab 104
  check "!revolt with", 24, 55 28 37 10, tab 104
  edit "", 25, 93 29 13 9, tab 104 autohs limit 2 center
  text "people", 504, 108 29 16 8, tab 104
  check "!points", 26, 55 39 26 10, tab 104
  check "!question", 27, 106 39 32 10, tab 104
  check "!vow", 28, 55 50 21 10, tab 104
  check "!help", 29, 106 50 22 10, tab 104
  check "!commands", 30, 55 61 37 10, tab 104
  check "!stop", 31, 106 61 22 10, tab 104
  check "!streak", 32, 55 72 27 10, tab 104
  check "!top", 33, 106 72 22 10, tab 104
  check "!rank", 34, 55 83 27 10, tab 104
  check "!players", 35, 106 83 29 10, tab 104
  check "!color", 36, 55 94 23 10, tab 104
  check "!stats", 37, 106 94 23 10, tab 104
  link "Help", 38, 137 95 11 8, tab 104
  text "Message type:", 550, 50 110 36 8, tab 104
  combo 39, 88 109 64 33, tab 104 size drop

  tab "Advanced Settings", 221
  box "When players join the channel", 306, 5 16 104 55, tab 221
  check "Welcome Msg:", 40, 9 23 44 10, tab 221
  edit "", 41, 9 33 96 10, tab 221 autohs
  text "Message type:", 69, 9 46 36 8, tab 221
  combo 42, 47 45 58 33, tab 221 size drop
  check "Give Voice", 43, 9 59 34 10, tab 221
  check "Give Ops", 44, 74 59 31 10, tab 221
  box "During quiz", 307, 5 71 104 45, tab 221
  check "End quiz after", 45, 9 79 43 10, tab 221
  edit "", 46, 52 80 13 9, tab 221 autohs limit 2 center
  text "inactive quest.", 508, 68 81 37 8, tab 221
  check "Voice active quizzers", 47, 9 91 59 10, tab 221
  check "Devoice after", 48, 9 103 42 10, tab 221
  edit "", 49, 52 104 13 9, tab 221 autohs limit 2 center
  text "inactive quest.", 509, 67 104 37 8, tab 221
  box "Punishments", 308, 111 16 43 69, tab 221
  check "Advert. Ban", 50, 114 23 38 10, tab 221
  check "Flood Ban:", 51, 114 33 35 10, tab 221
  edit "", 52, 114 43 13 9, tab 221 autohs limit 2 center
  text "msgs in", 510, 129 44 18 8, tab 221
  edit "", 53, 114 53 13 9, tab 221 autohs limit 2 center
  text "seconds", 511, 128 54 20 8, tab 221
  text "Ban", 551, 114 64 9 8, tab 221
  edit "", 54, 124 63 13 9, tab 221 autohs limit 2 center
  text "for", 552, 139 64 9 8, tab 221
  edit "", 55, 114 73 15 9, tab 221 autohs limit 3 center
  text "minutes", 553, 131 74 19 8, tab 221
  box "Congrats", 309, 111 85 43 31, tab 221
  check "Congrats", 56, 114 92 31 10, tab 221
  button "Edit Congrats", 57, 114 102 37 10, tab 221

  tab "Points", 78
  box "Players", 310, 5 15 95 63, tab 78
  list 58, 8 23 89 52, tab 78 size vsbar
  box "Points", 311, 102 15 51 63, tab 78
  list 59, 105 23 45 52, tab 78 size vsbar
  box "Player editing", 312, 5 78 148 19, tab 78
  button "Add player", 60, 8 85 36 9, tab 78
  button "Edit player", 61, 61 85 36 9, tab 78
  button "Delete player", 62, 113 85 36 9, tab 78
  box "Points editing", 313, 5 97 148 19, tab 78
  button "Add points", 63, 8 104 36 9, tab 78
  button "Edit points", 64, 61 104 36 9, tab 78
  button "Delete points", 65, 113 104 36 9, tab 78

  button "Apply", 997, 126 126 31 9, ok
  button "Ok", 998, 40 126 31 9, ok
  button "Cancel", 999, 80 126 31 9, cancel
}

dialog squiz_congrats {
  title "Edit Congratulations"
  size -1 -1 138 99
  option dbu
  box "# of correct answers in a row and congrulation", 400, 3 1 132 62
  list 1, 7 9 45 50, size vsbar
  list 2, 57 9 74 50, size hsbar vsbar
  box "Edit Congratulations", 500, 3 62 132 22
  button "Add", 3, 7 70 31 9
  button "Edit", 4, 54 70 31 9
  button "Delete", 5, 100 70 31 9
  button "Ok", 998, 31 87 31 9, ok
  button "Cancel", 999, 76 87 31 9, cancel
}

dialog squiz_hints {
  title "Edit Hints"
  size -1 -1 134 96
  option dbu

  box "Hint Settings", 400, 2 1 64 81
  text "# of Hints:", 500, 5 10 26 8
  edit "", 1, 34 9 17 9, limit 2 center
  text "Formula to determine points:", 501, 5 18 42 14
  edit "", 2, 5 34 59 9, autohs
  button "Calculate", 3, 5 44 31 9
  link "Help", 4, 52 44 11 8
  text "T = # of total Hints (6)", 502, 5 54 58 9
  text "H = # of Hints so far", 503, 5 63 58 9
  text "P = Points won", 504, 5 72 58 9
  box "Style", 401, 67 1 65 31
  radio "Style 1", 5, 70 8 26 10
  radio "Style 2", 6, 103 8 26 10
  button "Preview", 7, 70 19 26 10
  button "Preview", 8, 103 19 26 10
  box "Previews", 402, 67 32 65 50
  text "No Preview", 505, 69 39 27 42
  text "No Preview", 506, 102 39 27 42

  button "Ok", 998, 29 84 31 9, ok
  button "Cancel", 999, 74 84 31 9, cancel
}

dialog squiz_help {
  title "S-Quiz Help"
  size -1 -1 196 108
  option dbu

  box "Topics", 400, 3 2 60 92
  list 1, 6 10 54 81, size vsbar
  box "Description for", 401, 64 2 128 92
  edit "", 2, 67 10 122 81, read multi vsbar

  button "Ok", 998, 51 96 31 9, ok
  button "Cancel", 999, 106 96 31 9, cancel
}

on *:DIALOG:s-quiz:init:*:{

  if (!$hget(squiz)) return
  ; General

  if ($squiz($null).chans) { 
    didtok $dname 2 44 $v1
    did -c $dname 2 1
    var %chan = $did(2,1)
    did -a $dname 1 %chan
    if ($nopath($mid($squiz(%chan).qafile,2,-1))) did -a $dname 5 $v1
  }
  if ($squiz(general).hints) {
    if ($v1 == default) { did -c $dname 96 | did -b $dname 99 }
    else did -c $dname 98
  }
  if ($squiz(hteq).rounds) { 
    did -c $dname 7
    did -a $dname 555 $gettok($v1,1,32)
    if (* points * iswm $v1) { squiz tmp.rounds points | did -c $dname 8 | did -a $dname 9 $gettok($squiz(hteq).rounds,3,32) | did -m $dname 11 }
    else { squiz tmp.rounds questions | did -c $dname 10 | did -a $dname 11 $gettok($squiz(hteq).rounds,3,32) | did -m $dname 9 }
  }
  else { did -b $dname 8,10  | did -m $dname 555 }
  if (!$squiz(tmp).rounds) squiz tmp.rounds points
  if ($squiz(hteq).points) { did -c $dname 12 | did -a $dname 13 $v1 | did -m $dname 9,11 }
  else did -m $dname 13
  if ($squiz(hteq).dbempty) { did -c $dname 14 | did -m $dname 9,11,555 }
  if ($squiz(hteq).contplay) { did -c $dname 15 | did -m $dname 9,11,555 }
  if (!$hfind(squiz,hteq.*,1,w)) { did -b $dname 8,10,23,25,26 | did -m $dname 9,11,13,555 }

  ; Settings

  if ($squiz(time).start) did -a $dname 17 $v1
  else did -m $dname 17
  if ($squiz(time).hints) did -a $dname 18 $v1
  else did -m $dname 18
  if ($squiz(time).answer) did -a $dname 19 $v1
  else did -m $dname 19
  if ($squiz(time).nextq) did -a $dname 20 $v1
  else did -m $dname 20
  if ($squiz(trigger).revolt) { did -c $dname 24 | did -a $dname 25 $v1 }
  else did -m $dname 25
  if ($squiz(trigger).points) did -c $dname 26
  if ($squiz(trigger).question) did -c $dname 27
  if ($squiz(trigger).vow) did -c $dname 28
  if ($squiz(trigger).help) did -c $dname 29
  if ($squiz(trigger).commands) did -c $dname 30
  if ($squiz(trigger).stop) did -c $dname 31
  if ($squiz(trigger).streak) did -c $dname 32
  if ($squiz(trigger).top) did -c $dname 33
  if ($squiz(trigger).rank) did -c $dname 34
  if ($squiz(trigger).players) did -c $dname 35
  if ($squiz(trigger).color) did -c $dname 36
  if ($squiz(trigger).stats) did -c $dname 37
  didtok $dname 21 32 None 1 2
  ;didtok $dname 22,23 32 White Black Navy Green Red Maroon Purple Orange Yellow Lime Teal Aqua Blue Fuchsia Gray Silver
  if ($squiz(color).primary != $null) did -ra $dname 22 $v1
  else did -ra $dname 22 0
  if ($squiz(color).secondary != $null) did -ra $dname 23 $v1
  else did -ra $dname 23 1
  if ($squiz(color).settings == 2) did -c $dname 21 3
  elseif ($squiz(color).settings == 1) did -c $dname 21 2
  else did -c $dname 21 1
  ;elseif ($squiz(color).settings == 1) { did -c $dname 21 2 | did -h $dname 23 }
  ;else { did -c $dname 21 1 | did -h $dname 22,23 }
  didtok $dname 39,42 46 notice $!nick.msg $!nick.msg $!chan
  if ($squiz(msg).type1) did -c $dname 39 $v1

  ; Advanced Settings

  if ($gettok($squiz(join).msg,1,32)) did -c $dname 40 
  else did -m $dname 41
  did -a $dname 41 $gettok($squiz(join).msg,2-,32)
  else did -m $dname 41
  if ($squiz(msg).type2) did -c $dname 42 $v1
  if ($squiz(join).voice) did -c $dname 43
  if ($squiz(join).ops) did -c $dname 44
  if ($squiz(during).endquiz) { did -c $dname 45 | did -a $dname 46 $v1 }
  else did -m $dname 46
  if ($squiz(during).voice) did -c $dname 47
  if ($squiz(during).devoice) { did -c $dname 48 | did -a $dname 49 $v1 }
  else did -m $dname 49
  if ($squiz(punishments).advert) did -c $dname 50
  if ($squiz(punishments).flood) { 
    did -c $dname 51 
    did -a $dname 52 $gettok($v1,1,32)
    did -a $dname 53 $gettok($v1,2,32)
  }
  else did -m $dname 52,53
  if ($squiz(punishments).ban) {
    did -a $dname 54 $gettok($v1,1,32)
    did -a $dname 55 $gettok($v1,2,32)
  }
  else did -m $dname 52,53
  if ($squiz($null).en_congrats) did -c $dname 56
  else did -b $dname 57

  ; Points

  if ($hget(squiz.alltime,0).item) {
    var %w = @squiz.points,%s = 1
    if ($window(%w)) window -c %w
    window -h %w
    var %i = 1,%item = $hget(squiz.alltime,0).item
    while (%i <= %item) {
      aline %w $hget(squiz.alltime,%i).item $hget(squiz.alltime,%i).data
      inc %i
    }
    filter -cteuww 2 32 %w %w
    var %lines = $line(%w,0)
    while (%s <= %lines) {
      did -a $dname 58 $gettok($line(%w,%s),1,32)
      did -a $dname 59 $gettok($line(%w,%s),2,32)
      inc %s
    }
    did -z $dname 58,59
    did -c $dname 58,59 1
    window -c %w
  }
  if ($squiz(status)) {
    did -b $dname 7,8,10,12,14,15
    did -m $dname 9,11,13,555
  }
}


on *:DIALOG:s-quiz:sclick:*:{

  ; General

  if ($did == 2) {
    did -raf $dname 1 $did(2).seltext
    did -ra $dname 5 $nopath($mid($squiz($did(2).seltext).qafile,2,-1))
  }
  if ($did == 3) && ($did(1)) {
    var %text = $did(1)
    if ($left(%text,1) != $chr(35) || ($len(%text) < 2)) { did -f $dname 1 | return }
    did -a $dname 2 %text
    did -c $dname 2 $did(2).lines
    did -raf $dname 1
    did -r $dname 5
    if ($nopath($mid($squiz(%text).qafile,2,-1))) did -a $dname 5 $v1
  }
  if ($did == 4) && ($did(2).seltext) {
    var %text = $did(2).seltext,%line = $did(2).sel
    did -d $dname 2 %line
    var %line = $iif($did(2,%line),%line,%line - 1)
    if ($squiz(%text).qafile) squiz %text $+ .qafile-tmp-del
    did -c $dname 2 $iif($did(2,%line),%line,$calc(%line -1))
    did -raf $dname 1 $did(2).seltext
    if ($squiz(%text).qafile-tmp) squiz $+(%text,.qafile-tmp)
  }
  if ($did == 96) did -b $dname 99
  if ($did == 98) did -e $dname 99
  if ($did == 97) {
    dialog $iif($dialog(squiz_help),-v,-m squiz_help) squiz_help
    did -c squiz_help 1 2
    load.help Hints
  }
  if ($did == 99) dialog $iif($dialog(squiz_hints),-v,-m squiz_hints) squiz_hints
  if ($did == 6) && ($did(2).seltext) {
    var %file = $sfile($scriptdir*.txt,Select Question and Answer File,Done)
    if (%file) {
      squiz $+($did(2).seltext,.,qafile-tmp) $+(",%file,")
      did -ra $dname 5 $nopath(%file)
    }
  }
  if ($did == 7) { 
    did -e $dname 8,10 
    did -n $dname 9,11,555
    did -m $dname 13 
    if ($squiz(tmp.rounds) == points) { did -c $dname 8 | did -m $dname 11 }
    else { did -m $dname 9 | did -c $dname 10 }
  }
  if ($did == 8) { squiz tmp.rounds points | did -m $dname 11 | did -n $dname 9 }
  if ($did == 10) { squiz tmp.rounds questions | did -m $dname 9 | did -n $dname 11 }
  if ($did == 12) { did -m $dname 9,11,555 | did -n $dname 13 | did -b $dname 8,10 }
  if ($istok(14 15,$did,32)) { did -m $dname 9,11,13,555 | did -b $dname 8,10 }
  if ($did == 16) {
    dialog $iif($dialog(squiz_help),-v,-m squiz_help) squiz_help
    did -c squiz_help 1 4
    load.help Ending Quiz
  }
  if ($did == 91) did -o $dname 301 1 Q&&A File

  ; Settings / Advanced Settings

  if ($did == 38) {
    dialog $iif($dialog(squiz_help),-v,-m squiz_help) squiz_help
    did -c squiz_help 1 7
    load.help Triggers
  }
  if ($istok(24 40 45 48,$did,32)) did $iif($did($did).state,-n,-m) $dname $calc(1+$did)
  if ($did == 51) did $iif($did(51).state,-n,-m) $dname 52,53
  if ($did == 56) did $iif($did(56).state,-e,-b) $dname 57
  if ($did == 57) dialog $iif($dialog(squiz_congrats),-v,-m squiz_congrats) squiz_congrats

  ; Points

  if ($did == 58) did -c $dname 59 $did(58).sel
  if ($did == 59) did -c $dname 58 $did(59).sel
  if ($did == 60) {
    var %player = $input(What player should be added?,ei,Player Name)
    if (%player) { did -a $dname 58 %player | did -a $dname 59 0 | did -c $dname 58,59 $did(58).lines }
  }
  if ($did == 61) && ($did(58).seltext) {
    var %name = $input(What should the name be?,ei,Player Name,$did(58).seltext),%line = $did(58).sel
    if (%name) { did -o $dname 58 %line %name | did -c $dname 58 %line }
  }
  if ($did == 62) && ($did(58).seltext) {
    if ($input(Are you sure you want to permanently delete $v1 $+ ?,i,Delete $v1)) {
      var %line = $did(58).sel
      did -d $dname 58,59 %line
      did -c $dname 58,59 $iif($did(58,%line),%line,$calc(%line -1))
    }
  }
  if ($did == 63) && ($did(59).seltext != $null) {
    var %points = $input(How many points do you want to add to $did(58).seltext $+ 's points?,ei,Add how many points?,0)
    var %line = $did(59).sel
    if (%points != $null) { did -o $dname 59 %line $calc($did(59).seltext +%points) | did -c $dname 59 %line }
  }
  if ($did == 64) && ($did(59).seltext != $null) {
    var %points = $input(How many points should $did(58).seltext have?,ei,How many points?,$v1)
    var %line = $did(59).sel
    if (%points != $null) { did -o $dname 59 %line %points | did -c $dname 59 %line }
  }
  if ($did == 65) && ($did(59).seltext != $null) {
    var %points = $input(Delete how many of $did(58).seltext $+ 's $v1 points?,ei,Delete how many points?,0)
    var %line = $did(59).sel
    if (%points != $null) { did -o $dname 59 %line $calc($did(59).seltext -%points) | did -c $dname 59 %line }
  }

  ; Apply/Ok Button

  if ($did == 997) squiz.save
  if ($did == 998) squiz.save

}

on *:DIALOG:s-quiz:dclick:2:{
  var %a = $did(2).seltext,%sel = $did(2).sel,%file = $squiz(%a).qafile
  var %chan = $input(What should %a be?,ei,Edit %a,%a)
  if (%chan != %a) && ($left(%chan,1) == $chr(35)) {
    did -o $dname 2 %sel %chan
    did -ra $dname 1 %chan
    did -c $dname 2 1
    did -r $dname 5
    squiz $+(%chan,.qafile-tmp) %file
    if ($squiz($+(%a,.qafile-tmp))) squiz $+(%a,.qafile-tmp)
    squiz $+(%a,.qafile)
    if ($nopath($mid($squiz(%chan).qafile-tmp,2,-1))) did -a $dname 5 $v1
  }
}

on *:DIALOG:s-quiz:close:*:{ hdel -w squiz *.qafile-* | squiz tmp.rounds }

on *:DIALOG:s-quiz:edit:9,11,13,17,18,19,20,25,46,49,52,53,54,55:{
  if ($did($did) !isnum) did -raf $dname $did $rem.letter($did($did))
  if ($did == 18) did -ra $dname 19 $calc(4*$did(18))
}

alias squiz {
  if ($isid) {
    if ($shget($+($1,.,$prop)) != $null) return $v1
    if ($shget($prop) != $null) return $v1
    if ($shget($1) != $null) return $v1
  }
  else {
    if (!$1) dialog $iif($dialog(S-Quiz),-v,-m S-Quiz) S-Quiz
    if ($istok(General.Settings.Advanced Settings.Points.Help,$1-,46)) {
      if ($1 == Help) { dialog $iif($dialog(squiz_help),-v,-m squiz_help) squiz_help | return }
      dialog $iif($dialog(S-Quiz),-v,-m S-Quiz) S-Quiz
      did -c S-Quiz $calc(13*$len($1-))
      return
    }
    if ($1) && (!$2) hdel squiz $1
    if ($2 != $null) hadd squiz $1-
  }
}

alias -l ver return 1.7
alias -l shget return $hget(squiz,$1)
alias -l rem.letter {
  var %word
  .echo -q $regsub($1-,[^0-9]/g,.,%word)
  return %word
}

alias -l squiz.save {

  if (!$dialog(s-quiz)) return
  if (!$hget(squiz)) hmake squiz
  ; General

  var %i = 1,%r
  while (%i <= $did(2).lines) {
    var %chan = $did(2,%i)
    var %r = $addtok(%r,%chan,44) 
    if ($squiz(%chan).qafile-tmp) squiz %chan $+ .qafile $v1
    inc %i 
  }
  squiz chans %r
  hdel -w squiz *.qafile-tmp
  hdel -w squiz hteq.*
  if ($did(7).state) {
    if ($did(8).state) squiz hteq.rounds $iif($did(555),$did(555),3) points $iif($did(9),$did(9),150)
    else squiz hteq.rounds $iif($did(555),$did(555),3) questions $iif($did(11),$did(11),25)
  }
  hdel -w squiz general.*
  if ($did(96).state) squiz general.hints default
  if ($did(98).state) squiz general.hints custom
  if ($did(12).state) squiz hteq.points $iif($did(13),$did(13),150)
  if ($did(14).state) squiz hteq.dbempty 1
  if ($did(15).state) squiz hteq.contplay 1

  ; Settings

  hdel -w squiz time.*
  squiz time.start $iif($did(17),$did(17),5)
  squiz time.hints $iif($did(18),$did(18),10)
  squiz time.answer $iif($did(19),$did(19),40)
  if ($calc(4*$squiz(time).hints) > $squiz(time).answer) squiz time.answer $calc(4*$squiz(time).hints)
  squiz time.nextq $iif($did(20),$did(20),10)
  hdel -w squiz color.*
  squiz color.settings $did(21).seltext
  squiz color.primary $did(22)
  squiz color.secondary $did(23)
  hdel -w squiz trigger.*
  if ($did(24).state) squiz trigger.revolt $iif($did(25),$did(25),3)
  var %i = 26
  while (%i <= 37) {
    if ($did(%i).state) squiz trigger. $+ $remove($did(%i),!) 1
    inc %i
  }
  squiz msg.type1 $iif($did(39).sel,$did(39).sel,3)

  ; Advanced Settings

  hdel -w squiz join.*
  if ($did(40).state) squiz join.msg 1 $did(41)
  else squiz join.msg 0 $did(41)
  squiz msg.type2 $iif($did(42).sel,$did(42).sel,1)
  if ($did(43).state) squiz join.voice 1
  if ($did(44).state) squiz join.ops 1
  hdel -w squiz during.*
  if ($did(45).state) squiz during.endquiz $iif($did(46),$did(46),20)
  if ($did(47).state) squiz during.voice 1
  if ($did(48).state) squiz during.devoice $iif($did(49),$did(49),15)
  hdel -w squiz punishments.*
  if ($did(50).state) squiz punishments.advert 1
  if ($did(51).state) squiz punishments.flood $iif($did(52),$did(52),5) $iif($did(53),$did(53),2)
  squiz punishments.ban $iif($did(54),$did(54),3) $iif($did(55),$did(55),60)
  squiz en_congrats
  if ($did(56).state) squiz en_congrats 1

  ; Points

  if ($hget(squiz.alltime)) hdel -w squiz.alltime *
  if (!$hget(squiz.alltime)) hmake squiz.alltime
  var %i = 1
  while (%i <= $did(58).lines) {
    hadd squiz.alltime $did(58,%i) $did(59,%i)
    inc %i
  }
}

on *:DIALOG:squiz_congrats:*:*:{
  if ($devent == init) { load.congrats | load.queue }
  if ($devent == sclick) {
    if ($did == 1) did -c $dname 2 $did(1).sel
    if ($did == 2) did -c $dname 1 $did(2).sel
    if ($did == 3) && ($did(2).sel == $did(1).sel) {
      var %congrats = $input(Format for adding congratulations is $crlf $+ <#> - <congratulation> $&
        $crlf $+ i.e. 50 - $+(Wow,$chr(44)) impressive !nick,ei,Add Congarulation)
      if ($regex(%congrats,^([0-9]+) - (.+))) { 
        var %num = $regml(1),%congrat = $regml(2),%i = $did(1).lines,%r,%o
        while (%i) {
          if ($did(1,%i) == %num) { var %o = %i | break }
          if ($did(1,%i) > %num) && (($did(1,$calc(%i -1)) < %num) || (!$did(1,$calc(%i -1)))) { var %r = %i | break }
          dec %i
        }
        hadd -m squiz.queue congrats. [ $+ [ %num ] ] %congrat
        if (%o) { did -o $dname 2 %o %congrat | did -fc $dname 1,2 %o | return }
        if (%r) { did -i $dname 1 %r %num | did -i $dname 2 %r %congrat | did -fc $dname 1,2 %r | return }
        else { did -a $dname 1 %num | did -a $dname 2 %congrat | did -fc $dname 1,2 $did(1).lines | return }
      }
    }
    if ($did == 4) && ($did(1).sel == $did(2).sel) {
      var %num = $did(1).seltext
      var %line = $v1,%congrats = $input(Edit Congratulation,ei,Edit Congratulation,%num - $did(2).seltext)
      if ($regex(%congrats,^([0-9]+) - (.+))) { 
        hdel squiz.queue congrats. [ $+ [ %num ] ]
        hadd squiz.queue congrats. [ $+ [ $regml(1) ] ] $regml(2)
        load.congrats queue
      }
    }
    if ($did == 5) && ($did(1).sel == $did(2).sel) {
      var %line = $v1
      hdel squiz.queue congrats. [ $+ [ $did(1).seltext ] ]
      did -d $dname 1,2 %line
      did -c $dname 1,2 $iif($did(1,%line),%line,$calc(%line -1))
    }
    if ($did == 998) congrats.save
  }
  if ($devent == close) && ($hget(squiz.queue)) hfree squiz.queue
}

alias -l load.congrats {
  var %i = 1,%dname = squiz_congrats,%table,%w = @squiz.congrats
  did -r %dname 1,2
  if ($1) var %table = squiz.queue 
  else var %table = squiz
  if ($window(%w)) window -c %w
  window -h %w
  while ($hfind(%table,congrats.*,%i,w)) {
    var %ifmatch = $v1
    aline %w $gettok(%ifmatch,2,46) $hget(%table,%ifmatch)
    inc %i
  }
  filter -ctuww 1 32 %w %w
  var %i = 1,%lines = $line(%w,0)
  while (%i <= %lines) {
    did -a %dname 1 $gettok($line(%w,%i),1,32)
    did -a %dname 2 $gettok($line(%w,%i),2-,32)
    inc %i
  }
  did -z %dname 1,2
  if ($did(%dname,1,1)) did -c %dname 1,2 1
  window -c %w
}

alias -l load.queue {
  var %i = 1
  while ($hfind(squiz,congrats.*,%i,w)) {
    var %ifmatch = $v1
    hadd -m squiz.queue %ifmatch $shget(%ifmatch)
    inc %i
  }
}

alias -l congrats.save {
  var %i = 1,%lines = $did(1).lines
  hdel -w squiz congrats.*
  while (%i <= %lines) {
    squiz congrats. [ $+ [ $did(1,%i) ] ] $did(2,%i)
    inc %i
  }
}

on *:DIALOG:squiz_hints:*:*:{
  if ($devent == init) {
    if ($squiz(set.hints).num) { 
      did -a $dname 1 $v1 
      did -ro $dname 502 1 T = $chr(35) of total Hints $+($chr(40),$v1,$chr(41)) 
    }
    if ($squiz(set.hints).formula) did -a $dname 2 $v1
    if ($squiz(set.hints).style == 1) { did -c $dname 5 | did -b $dname 8 }
    elseif ($squiz(set.hints).style == 2) { did -c $dname 6 | did -b $dname 7 }
  }
  if ($devent == edit) && ($did(1) isnum 0-) did -o $dname 502 1 T = $chr(35) of total Hints ( $+ $did(1) $+ )
  if ($devent == sclick) {
    if ($did == 3) {
      var %i = 0,%s = 1,%r,%p,%formula = $replace($did(2),T,$did(1))
      while (%i <= 2) {
        var %num = $calc($($replace(%formula,H,%i),2))
        var %r = %r %i H = %num $+ $str($chr(160),$iif($len(%num) !isnum 1-2,$calc(4-$len(%num)),4) ) 
        inc %i
      }
      did -ro $dname 505 1 Answer after: $str($chr(160),7) %r etc.
    }
    if ($did == 4) {
      dialog $iif($dialog(squiz_help),-v,-m squiz_help) squiz_help
      did -c squiz_help 1 2
      load.help Hints
    }
    if ($did == 5) { did -b $dname 8 | did -e $dname 7 }
    if ($did == 6) { did -b $dname 7 | did -e $dname 8 }
    if ($istok(7 8,$did,32)) {
      var %i = 1,%r
      while (%i <= 6) { var %r = %r $+(%i,H) $($+($,makehint,$iif($did == 8,2),$chr(40),$(%i,0),$chr(44),Answer,$chr(41)),2) | inc %i }
      did -ro $dname $iif($did == 7,505,506) 1 %r
    }
    if ($did == 998) hints.save
  }
}

alias -l hints.save {
  hdel -w squiz set.hints.*
  var %formula = (T-H)*2
  squiz set.hints.num $iif($did(1),$did(1),3)
  squiz set.hints.formula $iif($did(2),$did(2),%formula)
  if ($did(5).state) squiz set.hints.style 1
  if ($did(6).state) squiz set.hints.style 2
}

on *:DIALOG:squiz_help:*:*:{
  if ($devent == init) {
    if (!$isfile($squiz_helpfile)) { 
      var %x = $input(The Help File could not be found. Please place squiz_help.ini in $+(",$scriptdir,"),w,Help File Not Found) 
      dialog -x $dname 
      return 
    }
    var %file = $squiz_helpfile,%i = 1,%r,%total = $ini(%file,0)
    while (%i <= %total) { var %r = $addtok(%r,$replace($ini(%file,%i),_,$chr(32)),44) | inc %i }
    didtok $dname 1 44 %r
    did -c $dname 1 1
    if ($did(1).seltext) {
      load.help $v1
      did -o $dname 401 1 Description for $did(1).seltext
    }
  }
  if ($devent == sclick) {
    if ($did == 1) {
      did -o $dname 401 1 Description for $replace($did(1).seltext,&,&&)
      load.help $did(1).seltext
    }
  }
}

alias -l squiz_helpfile return $+(",$scriptdir,squiz_help.ini,")
alias -l load.help { did -r squiz_help 2 | loadbuf $+(-ot,$replace($1-,$chr(32),_)) squiz_help 2 $squiz_helpfile }

; END OF DIALOGS

; ACCOUNTS

alias -l slget return $hget(squiz.accounts,$1-)
alias -l squiz_loggedin { 
  if ($slget($1- $+ .loggedin)) return $v1
  else return $false
}

; /squiz_reg username password
alias -l squiz_reg hadd -m squiz.accounts $1 $md5($2)
; /squiz_login nick username
alias -l squiz_login hadd -m squiz.accounts $1 $+ .loggedin $2
; /squiz_logout nick
alias -l squiz_logout hdel squiz.accounts $1 $+ .loggedin

on *:TEXT:!*:?:{
  ; Login
  if ($1 == !login) {
    if ($squiz_loggedin($nick)) { .msg $nick You are already logged in. | return }
    if (!$2) || (!$3) { .msg $nick Log in with: !login username password | return }
    if ($slget($2)) {
      if ($md5($3) == $v1) { squiz_login $nick $2 | .msg $nick You have successfully logged in. You have  $+ $iif($alltime($2),$v1,0) Points. }
      else .msg $nick Wrong password. Please try again.
    }
    else .msg $nick Wrong password or username or you don't have an account yet. Create an account with: !register username password
    closemsg $nick
  }
  ; Logout
  if ($1 == !logout) {
    if ($squiz_loggedin($nick)) { squiz_logout $nick | .msg $nick Successfully logged out. }
    else .msg $nick You are not logged in or you don't have an account. Create an account with: !register username password
  }
  ; Create an account
  if ($1 == !register) {
    if ($slget($2)) { .msg $nick That account already exists. | return }
    if ($3) { squiz_reg $2 $3 | .msg $nick Account successfully created. Log in with: !login $2 $3 $+  }
    closemsg $nick
  }
  ; Change PW
  if ($1 == !change.pw) {
    if (!$2) || (!$3) || (!$4) { msg $nick Format to change your password.: !change.pw username old-password new-password | return }
    if (!$squiz_loggedin($nick)) { .msg $nick You are not logged in. Log in with !login username password | return }
    if ($md5($3) != $slget($2)) { .msg $nick Wrong (old) password. }
    else { squiz_reg $2 $4 | squiz_logout $nick | .msg $nick Password changed. You were logged out. Log in with: !login $2 $4 $+  }
    closemsg $nick
  }
}

on *:NICK:{ 
  if ($squiz_loggedin($nick)) {
    squiz_login $newnick $v1
    squiz_logout $nick
  }
}

on *:PART:$($squiz($null).chans):{
  if ($squiz_loggedin($nick)) squiz_logout $nick
  if ($gettok($squiz(streaks),1,32) == $nick) squiz streaks
}

on *:QUIT:{
  if ($squiz_loggedin($nick)) squiz_logout $nick
  if ($gettok($squiz(streaks),1,32) == $nick) squiz streaks
}

; END OF ACCOUNTS

alias -l squiz.color return $+($chr(3),$squiz(color).primary,$chr(44),$squiz(color).secondary)
alias -l squiz.rcolor return $+($chr(3),$squiz(color).secondary,$chr(44),$squiz(color).primary)
alias -l scolor {
  if ($squiz(color).settings == none) return $null
  elseif ($squiz(color).settings == 1) return $squiz.color
  elseif ($squiz(color).settings == 2) {
    if ($1 == 1) return $squiz.color
    elseif ($1 == 2) return $squiz.rcolor
  }
  else return
}

alias -l squiz.flood {
  if ($isid) {
    if ($squiz($+($1,.flood))) halt
    else hadd -mu5 squiz $+($1,.flood) 1
  }
}

alias -l squiz.b return $+([,$1-,])

#squiz on
on !*:JOIN:#:{
  if (!$istok($squiz($null).chans,#,44)) return
  var %mode,%nick
  if ($me isop #) {
    if ($squiz(join).voice) { var %mode = $+(%mode,+v) | var %nick = %nick $nick }
    if ($squiz(join).ops) { var %mode = $+(%mode,+o) | var %nick = %nick $nick }
    if (%mode) && (%nick) mode # %mode %nick
  }
  $squiz.flood(join)
  if ($gettok($squiz(join).msg,1,32)) $($squiz.msg($squiz(msg).type2),2) $gettok($squiz(join).msg,2-,32)
}

on *:TEXT:*:#:{
  if (!$istok($squiz($null).chans,#,44)) return
  if ($squiz(flood). [ $+ [ $nick ] ] >= $gettok($squiz(punishments).flood,1,32)) && ($squiz(punishments).flood) {
    var %type = $gettok($squiz(punishments).ban,1,32),%time = $gettok($squiz(punishments).ban,2,32)
    ban -ku [ $+ [ $calc(60*%time) ] ] # $nick %type Don't flood. Banned for %time minutes. 
    return 
  }
  elseif ($squiz(punishments).flood) hinc -u [ $+ [ $gettok($squiz(punishments).flood,2,32) ] ] squiz flood. $+ $nick
  if ($len($wildtok($1-,#*,1,32)) >= 2) && ($wildtok($1-,#*,1,32) != #) && ($squiz(punishments).advert) {
    var %type = $gettok($squiz(punishments).ban,1,32),%time = $gettok($squiz(punishments).ban,2,32)
    ban -ku [ $+ [ $calc(60*%time) ] ] # $nick %type Don't advertise. Banned for %time minutes. 
    return 
  }

  var %msg = $($squiz.msg($squiz(msg).type1),2)
  if ($squiz_loggedin($nick)) var %nick = $v1
  else var %nick = $nick

  if ($istok(!login !register,$1,32)) {
    $squiz.flood(logreg)
    %msg For security reasons you cannot log in or register in the channel. To log in use /msg $me !login username password $&
      To register use /msg $me !register username password.
    return
  }

  if ($1 == !info) {
    $squiz.flood(info)
    if ($squiz(hteq).rounds) {
      tokenize 32 $v1
      %msg The Quiz will end after  $+ $1 rounds and each round ends after  $+ $3 $2 $+ 
    }
    if ($squiz(hteq).points) %msg The Quiz will end after one player has reached  $+ $v1 points
    if ($squiz(hteq).dbempty) %msg The Quiz will end after the database is empty.
    if ($squiz(hteq).contplay) %msg The Quiz won't end, it goes on forever until someone stops it.
    return
  }

  if ($1 == !commands) {
    $squiz.flood(commands)
    if (!$squiz(trigger).commands) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    var %triggers = revolt points question vow help commands stop streak top rank players color stats,%i = 1,%info = on
    while (%i <= $numtok(%triggers,32)) {
      var %tr = $gettok(%triggers,%i,32)
      if ($squiz(trigger). [ $+ [ %tr ] ]) var % [ $+ [ %tr ] ] on
      else var % [ $+ [ %tr ] ] off
      inc %i
    }
    %msg !revolt - $squiz.b(%revolt) <> !points - $squiz.b(%points) <> !question - $squiz.b(%question) <> $&
      !vow - $squiz.b(%vow) <> !help - $squiz.b(%help) <> 
    %msg !commands - $squiz.b(%commands) <> !stop - $squiz.b(%stop) <> !streak - $squiz.b(%streak) <> !top - $squiz.b(%top) <> $&
      !rank - $squiz.b(%rank) <> !players - $squiz.b(%players) <> !color - $squiz.b(%color) <> !stats - $squiz.b(%stats) <> !info - $squiz.b(%info)
  }

  if ($1 == !start) {
    if ($squiz(status)) {
      $squiz.flood(status)
      %msg Quiz is already running in $shget(status) $+ . 
      return
    }
    if (c isincs $gettok($chan(#).mode,1,32)) { msg # Cannot start quiz, because colors are not allowed. (+c) | return }
    squiz status #
    msg # $scolor(2) Quiz will start in $scolor(1) $squiz(time).start $scolor(2) seconds...  
    .timersquiz.quizstart 1 $squiz(time).start squiz_start #
  }

  if ($1 == !stop) {
    $squiz.flood(stop)
    if (!$squiz(status)) {
      %msg $+($nick,$chr(44)) No quiz is running.
      return
    }
    if (!$squiz(trigger).stop) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    squiz_stop # $nick
  }

  if ($1 == !revolt) {
    if (!$squiz(trigger).revolt) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    if ($question) {
      var %squiz.revolt = $squiz(revolt).num,%revolts = $squiz(trigger).revolt
      if ($istok($address($nick,3),%squiz.revolt,32)) { %msg $nick already requested a !revolt | return }
      else { 
        squiz revolt.num %squiz.revolt $address($nick,3) 
        %msg $calc(%revolts -$numtok($squiz(revolt).num,32)) more !revolts needed for the question to be skipped. 
      }
      var %squiz.revolt = $squiz(revolt).num
      if ($numtok(%squiz.revolt,32) >= %revolts) { set -u2 %revolt %revolts | squiz_answer # | return }
    }
    else %msg There is no question at the moment.
  }

  if ($1 == !points) {
    $squiz.flood(points)
    if (!$squiz(trigger).points) && ($squiz(status)) { %msg $nick $1 is disabled while the quiz is running. | return }
    if ($squiz_loggedin($2)) var %pnick = $2
    elseif ($2) var %pnick = $2
    else var %pnick = %nick
    %msg $scolor(1) %pnick $scolor(2) has $scolor(1) $iif($alltime(%pnick),$v1 Points,no Points yet) $+ . 
  }

  if ($1 == !question) { 
    $squiz.flood(question)
    if (!$squiz(trigger).question) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    elseif ($question) %msg The current question is: $+(,$question,)
    else %msg There is no question at the moment.
    return
  }

  if ($1 == !vow) {
    $squiz.flood(vow)
    if (!$squiz(trigger).vow) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    elseif ($answer) msg # $scolor(2) Vow.: $scolor(1) $vow($answer) 
    else %msg There is no question at the moment and therefore no answer.
    return
  }

  if ($1 == !help) {
    $squiz.flood(help)
    if (!$squiz(trigger).help) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    var %topics = trigger streak stats,%triggers = start stop info revolt points question vow help commands streak top rank players color stats
    if (!$2) { %msg Use !help [topic] to get help on a specific topic. Available topics: %topics | return }
    if (!$istok(%topics,$2,32)) { %msg No help available for that topic. Use !help to get a list of topics. | return }
    if ($2 == streak) %msg Any user can obtain a streak by answering two or more questions correctly in a row. $&
      You can use !streak to see who currently has the streak. You don't get anything for breaking someone elses streak, $&
      but the owner of the script can choose to set up "Congratulations" that send a little message when your streak reaches $&
      X questions. (configurable)
    if ($2 == stats) %msg The scripts gathers stats about you while you quiz. You can access these stats by !stats [nick] $&
      P/q means Points/question and tells you your average points you got for each question. s/a means seconds/answer and $&
      tells you your average answer-time for each correct answer. chars/s means characters/seconds and this gives you your $&
      average chars per second you had to type to get each correct answer. The rest should be self-explanatory.
    if ($2 == trigger) {
      if (!$3) { %msg Use !help trigger [trigger] to get help on a specific trigger. Available triggers: %triggers | return }
      if (!$istok(%triggers,$3,32)) { %msg No such trigger. Use !help trigger to get a list of triggers. | return }
      if ($3 == start) %msg !start - Starts the Quiz.
      if ($3 == stop) %msg !stop - Stops the Quiz.
      if ($3 == info) %msg !info - Tells you how the Quiz ends.
      if ($3 == revolt) %msg !revolt - Allows you to skip a question if enough people !revolt it.
      if ($3 == points) %msg !points [nick] - Tells you how points you or [nick] have.
      if ($3 == question) %msg !question - Gives you the current question.
      if ($3 == vow) %msg !vow - Uncovers all the vowels from the answer.
      if ($3 == help) %msg !help - Gives you help on the Quiz.
      if ($3 == commands) %msg !commands - Gives you a list of commands and if they are enable during the Quiz or not.
      if ($3 == streak) %msg !streak - Tells you who has the current streak and with how many questions.
      if ($3 == top) %msg !top [range] - Lists the Top players of the Quiz.
      if ($3 == rank) %msg !rank [nick] - Tells you your or [nick]'s rank in the High Score.
      if ($3 == players) %msg Tells you how many people are in the High Score.
      if ($3 == color) %msg !color 0|1|2 [color,code] - Lets you change the color settings of the Quiz.
      if ($3 == stats) %msg !stats [nick] - Gives you your or [nick]'s stats.
    }
  }

  if ($1 == !streak) {
    $squiz.flood(streak)
    if (!$squiz(trigger).streak) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    if ($squiz(streaks)) && ($squiz(status)) %msg The current streak is held by $gettok($squiz(streaks),1,32) with $gettok($squiz(streaks),2,32) questions.
    else %msg Either no one has a streak yet or no quiz is running.
  }

  if ($1 == !top) {
    $squiz.flood(top)
    if (!$squiz(trigger).top) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    if ($2) { %msg $scolor(2) Top $scolor(1) $2  | %msg $top($2)  }
    else { %msg $scolor(2) Top $scolor(1) 10  | %msg $top  }
  }

  if ($1 == !rank) {
    $squiz.flood(rank)
    if (!$squiz(trigger).rank) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    if ($2 isnum 0-) { %msg $scolor(2) $iif($getrank($2),$v1,Nobody) $scolor(1) $iif($numtok($getrank($2),32) == 2,are,is) $scolor(2) $ord($2) $+ .  | return } 
    elseif ($alltime($iif($2,$2,%nick))) %msg $scolor(2) $iif($2,$2,$nick) $scolor(1) is $scolor(2) $ord($rank($iif($2,$2,%nick))) $+ . 
    else %msg $scolor(2) $2 $scolor(1) has no points yet. 
  }

  if ($1 == !players) {
    $squiz.flood(players)
    if (!$squiz(trigger).players) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    %msg $scolor(1) Number of players who have 1 or more point(s): $scolor(2) $hget(squiz.alltime,0).item 
  }

  if ($1 == !color) {
    $squiz.flood(color)
    if (!$squiz(trigger).color) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    if ($2 == $null) {
      %msg Format to change the colors: !color 1|2|0 [color,code] $&
        If you don't specify a color,code you will just change how many colors are used. 
      return 
    }
    if ($3 == $null) && ($2 isnum 0-2) { squiz color.settings $2 | %msg $scolor(1) $2 color $+ $iif($2 != 1,s) $scolor(2) will now be used  | return }
    if ($3 != $null) {
      var %regex = /^([0-9]{1,2}),([0-9]{1,2})$/i
      if ($2 isnum 0-2) && (($regex($3,%regex)) || ($3 isnum 0-15)) {
        squiz color.settings $2
        squiz color.primary $iif($regml(1),$regml(1),$3)
        squiz color.secondary $iif($regml(2),$regml(2),0)
        %msg $scolor(1) $2 colors $scolor(2) will now be used $scolor(1) in this color. 
      }
    }
    else %msg $scolor(1) Invalid $scolor(2) numbers. $scolor(1) !color for format. 
  }

  if ($1 == !stats) {
    $squiz.flood(stats)
    if (!$squiz(trigger).stats) && ($squiz(status)) { %msg $1 is disabled while the quiz is running. | return }
    if ($squiz_loggedin($2)) var %nick = $2
    elseif ($2) var %nick = $2
    else var %nick = %nick
    var %stats = $stats.get(%nick)
    if (!%stats) { %msg $iif($2,$2,$nick) doesn't have any stats yet. | return }
    %msg Stats for $iif($2,$2,$nick)
    tokenize 32 %stats
    var %a = $round($calc(($1 /($1 +$2)*100)),2) $+ %
    %msg Answered wrong/correct - $+($2,/,$1,$chr(32),$chr(40),%a,$chr(41)) <> P/q - $round($calc($3 /$1),2) <> $&
      s/a - $round($calc($4 /$1),3) <> chars/s - $round($calc($5 /$1),3) <> Fastest chars/s - $round($6,3) <> Fastest answer - $round($7,3)
    return
  }

  if ($question) {
    if ($squiz(quiz).inactive) squiz quiz.inactive
    if ($squiz(inactive). [ $+ [ $nick ] ]) squiz inactive. $+ $nick
    if (!$istok($squiz(wrong),%nick,32)) hadd -m squiz wrong $squiz(wrong) %nick
    if ($nick !isvoice #) && ($me isop #) mode # +v $nick
    if ($isanswer($1-)) && (!%squiz.flood) { squiz_next # $nick | set -u [ $+ [ $squiz(time).nextq ] ] %squiz.flood 1 }
  }
}

alias -l squiz_start { 
  var %chan = $1
  if (!$isfile($quizfile(%chan))) { msg %chan Question database file does not exist. Cannot start quiz. | squiz status | return }
  else var %file = $quizfile(%chan)
  if (!$hget(squiz.alltime)) hmake squiz.alltime
  if (!$hget(squiz.points)) hmake squiz.points
  if (!$hget(squiz.quiz)) hmake squiz.quiz
  if ($squiz(hteq).dbempty) && (!$squiz(dbempty).change)  {
    var %file2 = $left(%file,-5) $+ 2.txt"
    .copy -o %file %file2
    var %file = %file2
    squiz %chan $+ .qafile %file2
    squiz dbempty.change 1
  }
  hadd squiz.quiz q# $r(1,$lines(%file)) 
  var %line = $read(%file,$q#)
  if ($squiz(hteq).dbempty) write -dl $+ $q# %file
  hadd squiz.quiz Question $gettok(%line,1,61)
  hadd squiz.quiz Answer $gettok(%line,2,61)
  if ($squiz(general).hints == custom) {
    var %i = 1,%b = $squiz(set.hints).num,%style = $iif($squiz(set.hints).style == 1,makehint,makehint2),%ht = $squiz(time).hints
    while (%i <= %b) {
      hadd squiz.quiz $+(Hint,%i) $($+($,%style,$chr(40),%i,$chr(44),$answer,$chr(41)),2)
      .timersquiz.quizhint $+ %i 1 $calc(%i *%ht) squiz_hint %chan
      inc %i
    }
  }
  else {
    var %i = 1,%ht = $squiz(time).hints
    while (%i <= 3) {
      hadd squiz.quiz $+(Hint,%i) $makehint(%i,$answer)
      .timersquiz.quizhint $+ %i 1 $calc(%i *%ht) squiz_hint %chan
      inc %i
    }
    /*
    var %ht = $squiz(time).hints
    hadd squiz.quiz Hint1 $makehint(1,$answer)
    hadd squiz.quiz Hint2 $makehint(2,$answer)
    hadd squiz.quiz Hint3 $makehint(3,$answer)
    .timersquiz.quizhint1 1 %ht squiz_hint %chan
    .timersquiz.quizhint2 1 $calc(2*%ht) squiz_hint %chan
    .timersquiz.quizhint3 1 $calc(3*%ht) squiz_hint %chan
    */
  }
  hadd squiz.quiz Time $ticks
  msg $1 $scolor(1) Question Number $scolor(2) $q# $+ : $scolor(1) $question 
  .timersquiz.answer.question 1 $squiz(time).answer squiz_answer %chan
  return
}

alias -l squiz_hint { 
  hinc -m squiz.quiz hints 
  msg $1 $scolor(2) Hint: $scolor(1) $hint  
}

alias -l squiz_answer { 
  set -u [ $+ [ $squiz(time).nextq ] ] %squiz.flood 1
  if (%revolt) { 
    msg $1 $scolor(1) The question was skipped $scolor(2) due to %revolt people $scolor(1) !revolt-ing. $scolor(2) Answer: $scolor(1) $answer  
    .timersquiz.quizhint* off
    .timersquiz.answer.*
  }
  else msg $1 $scolor(2) Nobody answered the question. $scolor(1) Answer: $scolor(2) $answer 
  hinc squiz asked.questions
  hfree squiz.quiz
  hinc squiz quiz.inactive
  if ($squiz_loggedin($2)) var %nick = $v1
  else var %nick = $2
  if ($squiz(wrong)) {
    var %i = 1
    while ($gettok($squiz(wrong),%i,32)) {
      var %ifmatch = $v1
      if (%ifmatch != %nick) {
        if (!$stats.get(%ifmatch)) stats.new %ifmatch
        squiz.stats %ifmatch #qwrong 1
      }
      inc %i
    }
  }
  squiz wrong

  var %i = 1,%s = 1
  if ($squiz_voice($1)) mode $1 $v1
  hdel -w squiz revolt.*
  if ($squiz(quiz).inactive >= $squiz(during).endquiz) {
    msg $1 $scolor(1) Quiz ended due to $scolor(2) $squiz(during).endquiz $scolor(1) rounds of inactivity. 
    hdel -w squiz.points *
    if ($hget(squiz.quiz)) hfree squiz.quiz
    squiz status
    squiz quiz.inactive
    squiz streaks
    hdel -w squiz.points *
    hdel -w squiz inactive.*
    hdel -w squiz asked.*
    hdel -w squiz revolt.*
    hdel squiz wrong
    .timersquiz.* off
    return
  }
  if (%mode) && (%nick) .timer 1 1 mode $1 %mode %nick
  if ($squiz(hteq).dbempty) squiz_check_win $1
  if (%squiz.bla) return
  .timersquiz.quizstart 1 $squiz(time).nextq squiz_start $1 
}

alias -l squiz_next {
  var %time = $squiz.length($calc((($ticks - $hget(squiz.quiz,time))/1000))),%nstreak = $gettok($squiz(streaks),2,32)
  var %bs = $squiz.length($round($calc(($len($answer) /$remove(%time,.)) *1000),2)),%c,%s = 1
  var %hints = $hget(squiz.quiz,hints),%num
  if ($squiz(general).hints == custom) {
    var %formula = $squiz(set.hints).formula,%total = $squiz(set.hints).num,%since = %hints
    var %num = $calc($($replace(%formula,T,%total,H,%since),2))
  }
  else {
    var %formula = (T-H)*2 ,%total = 3,%since = %hints
    var %num = $calc($($replace(%formula,T,%total,H,%since),2))
  }

  if ($squiz_loggedin($2)) var %nick = $v1
  else var %nick = $2

  ; Points
  hinc squiz.points %nick %num 
  hinc squiz.alltime %nick %num 

  ; Stats
  if (!$stats.get(%nick)) stats.new %nick
  squiz.stats %nick #q 1
  squiz.stats %nick #points %num
  squiz.stats %nick totalseconds %time
  squiz.stats %nick totalb/s %bs
  if ($squiz(wrong)) {
    var %i = 1
    while ($gettok($squiz(wrong),%i,32)) {
      var %ifmatch = $v1
      if (%ifmatch != %nick) {
        if (!$stats.get(%ifmatch)) stats.new %ifmatch
        squiz.stats %ifmatch #qwrong 1
      }
      inc %i
    }
  }
  squiz wrong
  if (%bs > $stats.r(%nick,fastestb/s)) squiz.stats %nick fastestb/s %bs
  if (%time < $stats.r(%nick,fastestanswer)) || ($stats.r(%nick,fastestanswer) == 0) squiz.stats %nick fastestanswer %time

  if ($gettok($squiz(hteq).rounds,2,32) == questions) hinc squiz asked.questions
  var %text = $+($chr(40),%c,$chr(32),%bs,$chr(32),chars/s,$chr(32),,$chr(41))
  var %w = $iif($r(1,2) == 1,Cool,Nice) $+ ,

  msg $1 $scolor(1) %w $scolor(2) $2 $+ . $scolor(1) $+(,$upper($answer),) $scolor(2) was the answer - $&
    $scolor(1) You got it in $scolor(2) $+(,%time,s,$chr(44)) %bs $+ $scolor(2) chars/s $scolor(1) Earned %num Points, $iif($points(%nick),$v1,%num) Total.

  if ($gettok($squiz(streaks),1,32) == $2) { inc %nstreak | squiz streaks $2 %nstreak }
  else { squiz streaks $2 1 | var %nstreak = 1 }
  if ($squiz(congrats). [ $+ [ %nstreak ] ]) {
    .echo -q $regsub($squiz(congrats). [ $+ [ %nstreak ] ],/!([^\s|!].*[^\s|!])/g,\$\1,%x)
    msg $1 $(%x,2)
    unset %x
  }
  .timersquiz.* off
  if ($hget(squiz.quiz)) hfree squiz.quiz
  hdel -w squiz revolt.*
  if ($squiz_voice($1)) mode $1 $v1
  squiz_check_win $1 $2 $points(%nick)
  if ($squiz(status)) .timersquiz.start 1 $squiz(time).nextq squiz_start $1 
}

alias -l squiz_stop { 
  .timersquiz.* off
  if ($answer) var %text =  $scolor(2) The answer was: $scolor(1) $answer $+ .
  else var %answer
  msg $1 $scolor(2) $2 $scolor(1) stopped the quiz. $iif(%text,%text) 
  if ($squiz(hteq).dbempty) { 
    var %file = $quizfile($1)
    squiz $1 $+ .qafile $left(%file,-6) $+ .txt" 
    hdel -w squiz dbempty.*
    .remove %file
  }
  if ($hget(squiz.points,1).item) hdel -w squiz.points *
  hdel -w squiz inactive.*
  hdel -w squiz quiz.*
  hdel -w squiz asked.*
  hdel -w squiz revolt.*
  if ($hget(squiz.quiz)) hfree squiz.quiz
  squiz streaks
  squiz status
  squiz quiz.inactive
}

alias -l squiz_over {
  if ($1 == points) var %text = $scolor(1) The round is over. $scolor(2) $3 $scolor(1) won the round with $scolor(2) $4 $scolor(1) points. $scolor(2) Congratulations! 
  if ($1 == rounds) var %text = $scolor(2) $3 $scolor(1) has won the $ord($4) round. 
  if ($1 == final) var %text = $scolor(2) $3 $scolor(1) has won the game after $4 rounds. $scolor(2) Congratulations! $&
    $scolor(1) Players who have won at least one game and their stats: $scolor(2) $5- 
  if ($1 == dbempty) {
    var %text = $scolor(2) The database is empty and here are the $scolor(1) Top 3 players $scolor(2) and their points: $scolor(1) $3-
    var %file = $quizfile($2)
    squiz $2 $+ .qafile $left(%file,-6) $+ .txt" 
    hdel -w squiz dbempty.*
    .remove %file
    set -u2 %squiz.bla 1
  }
  msg $2 %text
  .timersquiz.* off
  hdel -w squiz.points *
  hdel -w squiz inactive.*
  hdel -w squiz asked.*
  squiz streaks
  squiz quiz.inactive
  if ($hget(squiz.quiz)) hfree squiz.quiz
  if ($1 == rounds) { 
    .timersquiz.start 1 $calc(5+$squiz(time).start) squiz_start $1 
    msg $2 $scolor(2) $ord($calc(1+$4)) round $scolor(1) will start $&
      in $scolor(2) $calc(5+$squiz(time).start) $scolor(1) seconds.
  }
  else { squiz status | hdel -w squiz rounds.* | hdel -w squiz quiz.* }
}

alias -l squiz_check_win {
  if ($squiz_loggedin($2)) var %nick = $v1
  else var %nick = $2

  if ($squiz(hteq).contplay) return $false
  if ($squiz(hteq).dbempty) {
    if ($lines($quizfile($1)) == 0) {
      var %i = 1,%w = @most.points,%item = $hget(squiz.points,0).item
      if ($window(%w)) window -c %w
      window -h %w
      while (%i <= %item) {
        aline %w $hget(squiz.points,%i).item $hget(squiz.points,%i).data
        inc %i
      }
      filter -cteuww 2 32 %w %w
      var %i = 1,%lines = $line(%w,0),%r,%winner,%re
      if (%lines >= 3) var %lines = 3
      while (%i <= %lines) {
        if ($gettok($line(%w,%i),2,32) == $gettok(%r,-2,32)) var %re = $remove($gettok(%r,-5,32),:)
        else var %re = %i
        var %r = %r $scolor(2) $+(%re,:) $scolor(1) $line(%w,%i) <>
        inc %i 
      }
      squiz_over dbempty $1 %r
      window -c %w
    }
  }
  if ($squiz(hteq).points) && ($points(%nick) >= $squiz(hteq).points) { squiz_over points $1- }
  if ($squiz(hteq).rounds) {
    if ($gettok($squiz(hteq).rounds,2,32) == points) && ($points(%nick) >= $gettok($squiz(hteq).rounds,3,32)) {
      hinc squiz rounds.played
      hinc squiz rounds.won. $+ $2
      if ($squiz(rounds).played >= $gettok($squiz(hteq).rounds,1,32)) goto win
      else { squiz_over rounds $1 $2 $squiz(rounds).played | return }
    }
    elseif ($gettok($squiz(hteq).rounds,2,32) == questions) && ($squiz(asked).questions >= $gettok($squiz(hteq).rounds,3,32)) {
      hinc squiz rounds.played
      hinc squiz rounds.won. $+ $getrank(1,squiz.points)
      if ($squiz(rounds).played >= $gettok($squiz(hteq).rounds,1,32)) goto win
      else { squiz_over rounds $1 $2 $squiz(rounds).played | return }
    }
    else return
    :win
    ;hinc squiz rounds.won. $+ $iif($gettok($squiz(hteq).rounds,2,32) == questions,$getrank(1,squiz.points),$2)
    var %i = 1,%w = @rounds.won,%r,%winner
    if ($window(%w)) window -c %w
    window -h %w
    while ($hfind(squiz,rounds.won.*,%i,w)) { 
      aline %w $remove($v1,rounds.won.) $squiz($v1)
      inc %i
    }
    filter -cteuww 2 32 %w %w
    var %i = 1,%lines = $line(%w,0)
    while (%i <= %lines) {
      if ($gettok($line(%w,%i),2,32) > $gettok(%winner,2,32)) || (!%winner) var %winner = $line(%w,%i)
      var %r = %r $line(%w,%i) $iif(%i != %lines,$chr(124)) 
      inc %i 
    }
    window -c %w
    squiz_over final $1 $gettok(%winner,1,32) $squiz(rounds).played %r
  }
}

alias -l squiz_voice {
  var %s = 1,%i = 1
  while ($nick($1,%s,v)) { hinc squiz inactive. [ $+ [ $v1 ] ] | inc %s }
  var %mode,%nick
  while ($hfind(squiz,inactive.*,%i,w)) { 
    var %ifmatch = $v1
    if ($squiz(%ifmatch) >= $squiz(during).devoice) { 
      var %mode = $+(%mode,-v) 
      var %nick = %nick $remove(%ifmatch,inactive.)
      if ($squiz(inactive). [ $+ [ $remove(%ifmatch,inactive.) ] ]) squiz inactive. [ $+ [ $remove(%ifmatch,inactive.) ] ]
    }
    inc %i
  }
  if (%mode) && (%nick) return %mode %nick
}

alias -l top {
  var %i = 1,%1,%2,%items = $hget(squiz.alltime,0).item,%w = @squiz.top
  if ($window(%w)) window -c %w
  window -h %w
  if (*-* iswm $1) { var %1 = $gettok($1,1,45) | var %2 = $gettok($1,2,45) }
  if (*- iswm $1) var %1 = $gettok($1,1,45)
  while (%i <= %items) { aline %w $hget(squiz.alltime,%i).item $hget(squiz.alltime,%i).data | inc %i }
  filter -cteuww 2 32 %w %w
  var %i = 1,%res,%noone = $+(-,$chr(32),$chr(40),-,$chr(41)),%re
  if (%1) {
    if (%1 > %2) || (%1 == %2) return $scolor(1) Invalid $scolor(2) range 
    if ($calc(%2 -%1) > 14) return $scolor(1) Message too long. $scolor(2) Please narrow down the range. 
    if (%1 > $line(%w,0)) return $scolor(1) There are only $scolor(2) $line(%w,0) members $scolor(1) listed 
    if (!%2) var %2 = $iif($calc(%1 +14) <= $line(%w,0),$v1,$line(%w,0))
  }
  else {
    var %1 = 1
    if ($1) var %2 = $1
    else var %2 = 10
  }
  while (%1 <= %2) {
    if ($gettok(%res,-2,32) == $gettok($line(%w,%1),2,32)) var %re = $remove($gettok(%res,-4,32),:)
    else %re = %1
    var %res = %res $scolor(2) %re $+ : $scolor(1) $iif($line(%w,%1),$v1,%noone) <>
    inc %1 
  }
  window -c %w
  if ($len(%res) > 400) return $scolor(1) Message too long. $scolor(2) Please narrow down the range. 
  return %res
}

alias -l makehint { 
  var %i = $1, %r = $2,%s = $1
  while (%i <= $len($2)) { %r = $left(%r,%i) $+ .... $+ $right(%r,- $+ $calc(%i +4)) | inc %i 5 }
  if (%s != 1) %r = $str(.,$calc(%s -1)) $+ $right(%r,- $+ $calc(%s -1))
  if ($len(%r) > $len($2)) %r = $left(%r,$len($2))
  return %r 
}

alias -l makehint2 {
  var %word = $2,%num = $1,%r
  %r = $left(%word,$1) $+ $str(.,$len($right(%word,- $+ $1)))
  return %r
}

alias vow {
  var %word
  .echo -q $regsub($1-,/[^aeiouy]/g,.,%word)
  return %word
}

alias isanswer {
  if (!$answer) return
  var %answer = $replace($answer,*,.*),%1- = $strip($1-)
  var %answer2 = $squiz.regex(%answer),%regex = $+(/,%answer2,/i)
  if ($regex(%1-,%regex)) return $true
  else return $false
}

alias squiz.regex {
  var %r = $1-, $&
    %r = $replace(%r,,(?:||ue),,(?:||oe),,(?:||ae),,(?:|ss)), $&
    %r = $replace(%r,,(?:||ue),,(?:||oe),,(?:||ae),$chr(32),(?:\s+)?),%i = 10
  while (%i >= 0) {
    var %regex = $+(/,%i,|,$sub.num(%i),/ig)
    .echo -q $regsub(%r,%regex,$+($chr(40),?:,%i,|,$sub.num(%i),$chr(41)),%r)
    dec %i
  }
  return %r
}
alias sub.num {
  var %num = one.two.three.four.five.six.seven.eight.nine.ten
  ;var %num = eins?.zwei.drei.vier.fnf.sechs.sieben.acht.neun.zehn.elf
  return $iif($1 == 0,zero,$gettok(%num,$1,46))
}

alias -l getrank { 
  var %i = 1,%r,%n = $iif($2,$2,squiz.alltime)
  while ($hget(%n,%i).item) { 
    if ($rank($v1,%n) == $1) var %r = $iif(%r,%r $+ $chr(44)) $hget(%n,%i).item
    inc %i 
  }
  return %r
}

alias -l rank { 
  var %i = 1,%r, %rank = $alltime($1),%n = $iif($2,$2,squiz.alltime)
  while ($hget(%n,%i).data) { 
    if ($v1 != %rank) && ($v1 > %rank) inc %r
    inc %i
  } 
  return $calc(1+%r) 
}


alias -l squiz.length {
  var %time = $1-
  if ($len($gettok(%time,2,46)) < 3) || (. !isin %time) {
    var %time = $+($gettok(%time,1,46),.,$gettok(%time,2,46),$str(0,$calc(3-$len($gettok(%time,2,46)))))
  }
  return %time
}

alias -l squiz.msg {
  if ($1 == 1) return .notice $!nick
  elseif ($1 == 2) return .msg $!nick
  else return msg $!chan
}
#squiz end

alias -l quizfile return $squiz($1).qafile
alias -l q# return $hget(squiz.quiz,q#)
alias -l question return $hget(squiz.quiz,Question)
alias -l answer return $hget(squiz.quiz,Answer)
alias -l hint return $hget(squiz.quiz,hint [ $+ [ $hget(squiz.quiz,hints) ] ])

alias -l points return $hget(squiz.points,$1)
alias -l alltime return $hget(squiz.alltime,$1)

alias -l squiz.readme return $+(",$scriptdir,squiz_readme.txt,")
alias -l squiz.versions return $+(",$scriptdir,squiz_versions.txt,")
alias -l hmake {
  if ($hget($1)) hfree $1
  !hmake $1
}

alias -l squiz.unload {
  echo -a Unloading S-Quiz $ver ...
  echo -a Deleting files ...
  var %i = 1,%tables = squiz squiz.alltime squiz.stats squiz.accounts
  while ($gettok(%tables,%i,32)) {
    var %hash = $v1
    if ($hget(%hash)) hfree %hash
    if ($isfile($+(",$scriptdir,%hash,.dat,"))) .remove $+(",$scriptdir,%hash,.dat,")
    inc %i
  }
  .unload -rs $script
  echo -a Files deleted. Unloaded S-Quiz $ver
}
on *:UNLOAD:squiz.unload

; Stats Aliases
; Format:
; nick - #questions #questionswrong #points totalseconds totalb/s fastestb/s fastestanswer

alias -l stats.get return $hget(squiz.stats,$1)
alias -l stats.r {
  var %things = #q #qwrong #points totalseconds totalb/s fastestb/s fastestanswer 
  return $gettok($stats.get($1),$findtok(%things,$2,1,32),32) 
}
alias -l stats.new hadd -m squiz.stats $1 0 0 0 0 0 0 0
alias -l squiz.stats {
  var %things = #q #qwrong #points totalseconds totalb/s fastestb/s fastestanswer
  var %token = $findtok(%things,$2,1,32)
  if (%token isnum 6-7) var %item = $puttok($stats.get($1),$3,%token,32)
  else var %item = $puttok($stats.get($1),$calc($3 +$stats.r($1,$2)),%token,32)
  hadd -m squiz.stats $1 %item
}

on *:EXIT:{
  var %i = 1,%tables = squiz squiz.alltime squiz.stats squiz.accounts
  while ($gettok(%tables,%i,32)) {
    %hash = $v1
    if ($hget(%hash)) {
      if (%hash == squiz.accounts) hdel -w squiz.accounts *.loggedin
      hsave %hash $+(",$scriptdir,%hash,.dat,")
    }
    inc %i
  }
}

on *:START:.echo -q $findfile($scriptdir,squiz*dat,0,0,squiz.load.hash $1-)

alias -l squiz.load.hash {
  var %table = $left($nopath($1-),-4)
  if (!$hget(%table)) hmake %table
  hload %table $+(",$1-",)
}

on *:LOAD:{
  if ($version < 6.16) {
    echo -a This Quiz was tested on mIRC 6.16 and you have version $version $+ . 
    echo -a This script will not work with $version as it uses commands only available in 6.16 and newer versions.
    echo -a Please update your mIRC at www.mirc.com
    .unload -rs $+(",$script,")
  }
  echo -a Thanks for downloading Quiz Script $ver by SSJ4_Son_Goku
  if ($isfile($+(",$scriptdir,squiz.dat,"))) { hmake squiz | hload squiz $+(",$scriptdir,squiz.dat,") }
  if ($isfile($squiz.readme)) run $squiz.readme
}
